#include "error.hh"

bool HandlingError = false;
std::list<jmp_buf> ErrorFrameStack;
jmp_buf ErrorSpot, SafeReturnToMain;
void* ErrorHandler, *ResumeTarget;
int B_ERL_VALUE, B_ERR_VALUE;

static void B_RESUME_FAILTEST()
{
    if(!HandlingError) B_ERROR(20);/* RESUME WITHOUT ERROR*/
}
/* RESUME and RESUMENEXT may return into a subprogram, but also to main program */
void B_RESUME()
{
    B_RESUME_FAILTEST();
    longjmp(ErrorFrameStack.back(), 1);
}
void B_RESUME_NEXT()
{
    B_RESUME_FAILTEST();
    longjmp(ErrorFrameStack.back(), 2);
}
void B_ERR_PUSH()
{
    ErrorFrameStack.push_back(ErrorSpot);
}
void B_ERR_POP()
{
    ErrorSpot = ErrorFrameStack.back();
    ErrorFrameStack.pop_back();
}
void B_ERROR(BAS_INT code)
{
    B_ERL_VALUE = 0; //FIXME
    B_ERR_VALUE = code;
    
    if(HandlingError || !ErrorHandler)
    {
        fprintf(stderr, "error message %d\n", (int)code);
        exit(code);
    }
    goto *ErrorHandler;
}
