#include <iostream>
#include "typenameof.hh"
#include "stmt.hh"

stmt::stmt()
{
}
stmt::~stmt()
{
}

void stmt::Compile(const Scope& scope)
{
    std::cout << "    /* Compilation of "
              << typenameof(*this)
              << " not supported */\n";
}

static bool IsEntirelyIntegerCase(exprp exp)
{
    if(!exp) return false;
    
    if(dynamic_cast<expr_caseelse*>(&*exp))
    {
        return true;
    }
    if(expr_caseor* e = dynamic_cast<expr_caseor*>(&*exp))
    {
        return IsEntirelyIntegerCase(e->a) && IsEntirelyIntegerCase(e->b);
    }
    if(expr_caseis* e = dynamic_cast<expr_caseis*>(&*exp))
    {
        if(e->token != (QBtoken)'=') return false;
        return IsEntirelyIntegerCase(e->ref);
    }
    if(expr_caserange* e = dynamic_cast<expr_caserange*>(&*exp))
    {
        return IsEntirelyIntegerCase(e->min) && IsEntirelyIntegerCase(e->max);
    }
    
    if(!exp->is_const()) return false;
    
    TypeP type = exp->get_type();
    if(!type) return false;
    return
      (type->Type == TypeInfo::Integer
    || type->Type == TypeInfo::Long);
}

bool stmt_select::IsEntirelyIntegerCase() const
{
    for(std::list<std::pair<exprp, stmtp> >::const_iterator
        i = cases.begin(); i != cases.end(); ++i)
    {
        if(!::IsEntirelyIntegerCase(i->first)) return false;
    }
    return true;
}
